#!/user/local/bin/ruby -Ks
def showHelp; scrName = File::basename($0.gsub(/\\/, '/'));
puts <<"================================================"
#{scrName} v1.01  Copyright (C) 2003, nomad
Tv: Longman 4  EBStudio p̓t@C쐬
\: ruby -Ks #{scrName} [option] homeDir [outDir, [drive]]
  option -[A|B|C|D]  o͂鎫 (wȂȂ -ABCDA܂肷ׂďo)
           -A  Activator
           -B  Bank (ᕶEp)
           -C  Collocation (A)
           -D  Dictionary ({)
  homeDir Longman 4 CXg[fBNg
  outDir  o̓fBNg (wȂȂJgfBNg)
  drive   CD-ROM hCu (wȂȂ D:AMinimal CXg[ɕKv)
:
* 쐬 (FullAStandard CXg[)
  ruby -Ks #{scrName} E:\\LDOCE4 D:\\EPWING\\ldoce4
* 쐬 (Minimal CXg[AF: hCu LDOCE4 CD-ROM })
  ruby -Ks #{scrName} E:\\LDOCE4 D:\\EPWING\\ldoce4 F:
* {̂ Activator o (FullAStandard CXg[)
  ruby -Ks #{scrName} -AD E:\\LDOCE4 D:\\EPWING\\ldoce4
================================================
end
=begin
o: *.html  EBStudio ̓t@C
      *.ebs   EBStudio Ɗ`t@C
:
  v1.00 2003-11-20 by nomad
    J
  v1.01 2003-12-04 by nomad
    Phrase Bank  Examples Bank ̍ڂȂoA11000
    o͂ȂoOC
  v1.02 2003-12-04 by nomad
    title="..." Ƀ^O܂܂ EBStudio ̂ɑΉ (dic.rb)
  v1.03 2004-02-04 by nomad
    bank.html ɗ]vȌoo͂Ă̂C (v1.01 ō)
: Copyright (C) 2003-2004, nomad
      I[v\[X
=end

  scrPath = File::dirname($0.gsub(/\\/, '/'))
  $LOAD_PATH.unshift(scrPath)     # XNvgpX[hpXɒǉ

  require 'ldoce4/cfg'
  require 'ldoce4/dic'
  require 'ldoce4/example'
  require 'ldoce4/phrase'
#  require 'ldoce4/example-rexml'
#  require 'ldoce4/phrase-rexml'
  require 'ldoce4/activator'

#  include GC
#  GC::enable

### 萔

MAX_DIC    = 47636    # R[h

SEP_LINE = '' * 10  # ؂

F_DIC    = 0    # 
F_BANK   = 1    # Phrase Bank & Examples Bank
F_COLLOC = 2    # Collocation
F_ACT    = 3    # Activator

EBSFname      = 'LDOCE4.ebs'
GaiziFname    = 'LDOCE4Gaiji.xml'
GaiziMapFname = 'LDOCE4GaijiMap.xml'

DicData = [
  {
    'title'    => 'Longman 4th Edition',  # ^Cg
    'outfname' => 'ldoce4.html',          # o̓t@C
    'dir'      => 'LDOCE4',               # EPWING fBNg
  },
  {
    'title'    => 'LDOCE4 Examples and Phrases',   # ^Cg
    'outfname' => 'bank.html',            # o̓t@C
    'dir'      => 'BANK',                 # EPWING fBNg
  },
  {
    'title'    => 'LDOCE4 Collocation',   # ^Cg
    'outfname' => 'colloc.html',          # o̓t@C
    'dir'      => 'COLLOC',               # EPWING fBNg
  },
  {
    'title'    => 'Longman Activator',    # ^Cg
    'outfname' => 'activator.html',       # o̓t@C
    'dir'      => 'ACTIV',                # EPWING fBNg
  },
]

Conv = [false, false, false, false]   # 쐬IvV

###
def changeExt(fname, newExt)
  fname.sub(/\.[^.]+$/, newExt)
end

def copyFile(inPath, outPath)
  return if File::expand_path(inPath) == File::expand_path(outPath)

  inf = open(inPath, 'rb')
  outf = open(outPath, 'wb')
  outf.write(inf.read())

rescue => e
  STDERR.puts e.message
ensure
  inf.close if inf != nil
  outf.close if outf != nil
end

class EBSFile < File

  def printEBS(outDir)

    outDir = outDir.gsub(/\//, '\\')

    puts <<"--------"
InPath=#{outDir}\\
OutPath=#{outDir}\\
IndexFile=
Copyright=
GaijiFile=$(BASE)\\#{GaiziFname}
GaijiMapFile=$(BASE)\\#{GaiziMapFname}
EBType=0
WordSearchHyoki=1
WordSearchKana=1
EndWordSearchHyoki=1
EndWordSearchKana=1
KeywordSearch=1
ComplexSearch=0
topMenu=0
singleLine=1
kanaSep1=y
kanaSep2=z
hyokiSep=0
makeFig=1
paraHdr=0
ruby=1
paraBr=0
subTitle=1
dfnStyle=1
srchUnit=0
linkChar=0
arrowCode=222A
eijiPronon=1
eijiPartOfSpeech=1
eijiBreak=1
eijiKana=0
leftMargin=1
indent=0
tableWidth=480
StopWord=a the
delBlank=1
delSym=1
delChars=
refAuto=0
titleWord=1
autoWord=0
autoEWord=0
HTagIndex=1
DTTagIndex=1
dispKeyInSelList=0
titleOrder=0
addKana=1
autoKana=0
channel=0
nBit=0
sampLate=2
optMono=0
Size=230000;90000;4000;89000000;8000;350000;50000;2000;500;90000;2000
--------

    DicData.each do |dic|
      title = dic['title']
      dir = dic['dir']
      outfname = dic['outfname']
      puts <<"--------"
Book=#{title};#{dir};paT;_;_;GAI16H00;GAI16F00;_;_;_;_;_;_;
Source=$(BASE)\\#{outfname};_;_;HTML;
--------
    end

  end

end

###
class OutHTML < File

  def writeHeader(title = '')
    puts '<html>'
    puts '<head>'
    puts '<title>' + title + '</title>'
    puts '</head>'
    puts '<body>'
  end

  def writeFooter()
    puts '</body>'
    puts '</html>'
  end

end

# G[
def pathError
#  showHelp
  STDERR.puts <<EOS
Longman  CD-ROM } CD-ROM hCu𐳂w肵ĂB
EOS
  exit 1
end

# oo
def printHwd(id, maindoc, outf)

  title = maindoc.title(id)

  if title =~ /  (\d, )?/      # oAԌԍAiɕ
    hwd = $`; num = $1; parts = $'
  else
    hwd = title; num = nil; parts = ''
  end
  if num != nil
    outf.print '<h1 id="', ID_CHAR_EXA, id, '" title="', title, '">', hwd, "</h1>\n"
    outf.print '<p>', num, '<i>', parts, "</i></p>\n"
  elsif parts != ''
    outf.print '<h1 id="', ID_CHAR_EXA, id, '">', hwd, "</h1>\n"
    outf.print '<p><i>', parts, "</i></p>\n"
  else
    outf.print '<h1 id="', ID_CHAR_EXA, id, '">', hwd, "</h1>\n"
    outf.print "<p></p>\n"
  end

end

# AᕶAAo
def writeDic(home, outDir, drive, dic)

  maindoc = MainDoc::new(home, drive)
  if maindoc.package(PID_ENTRY) == nil
    pathError()
  end

  msg = []
  if Conv[F_DIC]
    dicDic = dic[F_DIC]
    outfDic = OutHTML::new(outDir + '/' + dicDic['outfname'], 'w')
    dicbody = DicBody::new(outfDic, maindoc, outDir)
    msg.push('')
  end
  if Conv[F_BANK]
    dicBank = dic[F_BANK]
    outfBank = OutHTML::new(outDir + '/' + dicBank['outfname'], 'w')
    dicphr = DicPhrase::new(outfBank)
    otherphr = OtherPhrase::new(outfBank)
    dicexa = ExampleDic::new(outfBank, maindoc)
    phrexa = ExamplePhrase::new(outfBank)
    msg.push('ᕶEp')
  end
  if Conv[F_COLLOC]
    dicColloc = dic[F_COLLOC]
    outfColloc = OutHTML::new(outDir + '/' + dicColloc['outfname'], 'w')
    colloc = CollocMenu::new(outfColloc, maindoc)
    msg.push('Aꎫ')
  end

  STDERR.print msg.join('A'), "o͂Ă܂...\n"

  outfDic.writeHeader(dicDic['title']) if Conv[F_DIC]
  outfBank.writeHeader(dicBank['title']) if Conv[F_BANK]
  outfColloc.writeHeader(dicColloc['title']) if Conv[F_COLLOC]

  n = 0
  maindoc.each_with_index do |rec, num|

    case rec['key']
    when KEY_DIC
      STDERR.print n, '/', MAX_DIC, "\r"  if n % 10 == 0
#      GC::start if n % 1000 == 0
break if $DEBUG && n >= 1000
      n += 1

      idx = maindoc.getbodyindex(rec)
      dicidx = exaidx = phridx = nil
      idx.each do |x|
        case x['packid']
          when PID_ENTRY   then dicidx = x
          when PID_EXAMPLE then exaidx = x
          when PID_PHRASE  then phridx = x
        end
      end
###      next if exaidx == nil && phridx == nil  #<- Bug!! v1.01

      if dicidx != nil && Conv[F_DIC]
        data = maindoc.getbody(dicidx)
        dicbody.do(data.chomp(REC_SEP))
      end

      next if exaidx == nil && phridx == nil  #<- Bug!! v1.03

      printHwd(num, maindoc, outfBank) if Conv[F_BANK]

      if exaidx != nil && Conv[F_BANK]
        data = maindoc.getbody(exaidx)
        dicexa.do(data.chomp(REC_SEP))
      end
      if phridx != nil && ( Conv[F_BANK] || Conv[F_COLLOC] )
        data = maindoc.getbody(phridx).chomp(REC_SEP)
        if data =~ %r!<div id="(\d+)" .+?>(<div id="divDicphr">.*?</div>)(.+?)(<div id="divWords">.*</div>)</div>\z!m
          id = $1; divDic = $2; divOthers = $3; divWords = $4

          if Conv[F_BANK]
            phrs = dicphr.do(divDic)
            otherphr.do(divOthers)

            outfBank.print '<p>', SEP_LINE, "</p>\n" if phrs.size > 0
            phrs.each do |phr|
              rec = maindoc.getrec(phr['id'].to_i)
              idx = maindoc.getbodyindex(rec)
              idx.each do |x|
                if x['packid'] == PID_EXAMPLE
                  data = maindoc.getbody(x)
                  phrexa.do(data.chomp(REC_SEP))
                end
              end
            end
          end

          if Conv[F_COLLOC]
            colloc.do(divWords, id.to_i)
          end
        end

      end

    when KEY_ACT_CONCEPT
      ;  # ǂݔ΂
    else
      break
    end

  end

  outfDic.writeFooter if Conv[F_DIC]
  outfBank.writeFooter if Conv[F_BANK]
  outfColloc.writeFooter if Conv[F_COLLOC]

  STDERR.print n, '/', MAX_DIC, "\n"

  maindoc.close
  outfDic.close if Conv[F_DIC]
  outfBank.close if Conv[F_BANK]
  outfColloc.close if Conv[F_COLLOC]

end

# Activator o
def writeAct(home, outDir, drive, dic)

  maindoc = MainDoc::new(home, drive)
  conceptf = maindoc.package(PID_ACT_CONCEPT)
  if conceptf == nil
    pathError
  end

  dicAct = dic[F_ACT]
  outf = OutHTML::new(outDir + '/' + dicAct['outfname'], 'w')

  menu = ActMenu::new(home, outf)
  section = ActBody::new(outf)

  # oꗗe[u̍쐬

  STDERR.print "Activator e[u쐬Ă܂..."
  reccount = menu.makeHeadwordsTable
  STDERR.print "  \n"

  # {̏o

  STDERR.print "Activator o͂Ă܂...\n"

  outf.writeHeader(dicAct['title'])

  n = 0
  conceptf.each do |rec|

    STDERR.print n, '/', reccount, "\r"  # if n % 10 == 0
break if $DEBUG && n >= 10
    n += 1

    # ڎo
    ids = menu.do(rec.chomp(REC_SEP))

    # {o
    ids.each do |id|
      rec = maindoc.getrec(id)
      idx = maindoc.getbodyindex(rec)
      idx.each do |x|
        if x['packid'] == PID_ACT_BODY
          section.do(maindoc.getbody(x).chomp(REC_SEP))
        end
      end
    end
  end

  outf.writeFooter

  STDERR.print n, '/', reccount, "\n"

  maindoc.close
  menu.close
  section.close

  outf.close
end

###

  # R}hC̏
  def ARGV.option
    return nil if self.empty?
    arg = self.shift
    if arg =~ /^-/
      return arg
    else
      self.unshift arg
      return nil
    end
  end

def main(scrPath)

  begin
    while option = ARGV.option
      if option =~ /^-[ABCD]+$/
        Conv[F_ACT]    = true if option =~ /A/ # Activator
        Conv[F_BANK]   = true if option =~ /B/ # Bank
        Conv[F_COLLOC] = true if option =~ /C/ # Collocation
        Conv[F_DIC]    = true if option =~ /D/ # Dictionary
      else
        raise 'ȃIvVł: ' + option
      end
    end
    raise "\nLDOCE4 CXg[fBNgw肵Ă" if ARGV.size < 1
  rescue => e
    showHelp()
    STDERR.puts e.message
    exit 2
  end

  unless Conv.include?(true)
    Conv[F_ACT]    = true  # Activator
    Conv[F_BANK]   = true  # Bank
    Conv[F_COLLOC] = true  # Collocation
    Conv[F_DIC]    = true  # Dictionary
  end

  homeDir = ARGV.shift.gsub(/\\/, '/')
  homeDir.sub!(/\/$/, '')
  outDir = if ARGV.size > 0 then ARGV.shift.gsub(/\\/, '/') else '.' end
  outDir.sub!(/\/$/, '')
  drive = if ARGV.size > 0 then ARGV.shift else 'D:' end
  drive = drive.sub(/:$/, '') + ':'

  home = homeDir + '/ldoce-data'

  start = Time::now
  STDERR.print "Jn: ", start.strftime('%Y-%m-%d %X'), "\n"

  # f[^o
  writeDic(home, outDir, drive, DicData) if Conv[F_DIC] || Conv[F_BANK] || Conv[F_COLLOC]
  writeAct(home, outDir, drive, DicData) if Conv[F_ACT]

  # Ɗ`t@Co
  EBSFile::open(outDir + '/' + EBSFname, 'w') do |f|
    f.printEBS(outDir)
  end

  # Ot@C̃Rs[
  copyFile(scrPath + '/' + GaiziFname, outDir + '/' + GaiziFname)
  copyFile(scrPath + '/' + GaiziMapFname, outDir + '/' + GaiziMapFname)

  finish = Time::now
  STDERR.print "I: ", finish.strftime('%Y-%m-%d %X'), "\n"
  STDERR.print ": ", Time::at(finish.to_i - start.to_i).utc.strftime('%X'), "\n"

end

main(scrPath)
